#property copyright "Copyright  2010 - 2011,  ,   AMRo"
#property link      "cmillion@narod.ru, nemo811@mail.ru"
#property show_inputs
/*
     ,       
 Magic .          .
    6  .       
  10   ,     .
*/
//--------------------------------------------------------------------
extern int     MAGIC       = 0;        //  
extern string  t1="    ";
extern bool    BUY         = false;    //  BUY
extern bool    SELL        = false;    //  SELL
extern string  t2="    ";
extern bool    BUY_STOP    = false;    //  BUY STOP
extern bool    BUY_LIMIT   = false;    //  BUY LIMIT
extern bool    SELL_STOP   = false;    //  SELL STOP
extern bool    SELL_LIMIT  = false;    //  SELL LIMIT
extern string  t3="      ";
extern double  Lot         = 0.1;      // 
extern int     takeprofit  = 0;        //  TP,  0,  TP  
extern int     stoploss    = 0;        //  SL,  0,  SL  
extern int     DistanceSet = 35;       //    
extern int     Proskalz    = 3;        //      
//--------------------------------------------------------------------
double SL,TP;
//--------------------------------------------------------------------
int start()
{
   if (BUY)
   {
      if (takeprofit!=0) TP  = NormalizeDouble(Ask + takeprofit*Point,Digits); else TP=0;
      if (stoploss!=0)   SL  = NormalizeDouble(Ask - stoploss*Point,Digits); else SL=0;     
      OPENORDER ("Buy");
      BUY=false;
   }
   if (SELL)
   {  
      if (takeprofit!=0) TP = NormalizeDouble(Bid - takeprofit*Point,Digits); else TP=0;
      if (stoploss!=0)   SL = NormalizeDouble(Bid + stoploss*Point,Digits);  else SL=0;              
      OPENORDER ("Sell");
      SELL=false;
   }
   if (BUY_STOP)
   {
      if (takeprofit!=0) TP  = NormalizeDouble(Ask + DistanceSet*Point + takeprofit*Point,Digits); else TP=0;
      if (stoploss!=0)   SL  = NormalizeDouble(Ask + DistanceSet*Point - stoploss*Point,Digits); else SL=0;     
      OPENORDER ("Buy Stop");
      BUY_STOP=false;
   }
   if (SELL_STOP)
   {  
      if (takeprofit!=0) TP = NormalizeDouble(Bid - DistanceSet*Point - takeprofit*Point,Digits); else TP=0;
      if (stoploss!=0)   SL = NormalizeDouble(Bid - DistanceSet*Point + stoploss*Point,Digits);  else SL=0;              
      OPENORDER ("Sell Stop");
      SELL_STOP=false;
   }
   if (BUY_LIMIT)
   {
      if (takeprofit!=0) TP  = NormalizeDouble(Ask - DistanceSet*Point + takeprofit*Point,Digits); else TP=0;
      if (stoploss!=0)   SL  = NormalizeDouble(Ask - DistanceSet*Point - stoploss*Point,Digits); else SL=0;     
      OPENORDER ("Buy Limit");
      BUY_LIMIT=false; 
   }
   if (SELL_LIMIT)
   {  
      if (takeprofit!=0) TP = NormalizeDouble(Bid + DistanceSet*Point - takeprofit*Point,Digits); else TP=0;
      if (stoploss!=0)   SL = NormalizeDouble(Bid + DistanceSet*Point + stoploss*Point,Digits);  else SL=0;              
      OPENORDER ("Sell Limit");
      SELL_LIMIT=false;
   }
return(0);
}
//--------------------------------------------------------------------
void OPENORDER(string ord)
{
   int ticket = -1;
   int err;
   while (ticket<0)
   {
      if (ord=="Buy") ticket=OrderSend(Symbol(),OP_BUY, Lot,NormalizeDouble(Ask,Digits),Proskalz,SL,TP,"MAGIC_" + MAGIC,MAGIC,0);
      if (ord=="Sell") ticket=OrderSend(Symbol(),OP_SELL,Lot,NormalizeDouble(Bid,Digits),Proskalz,SL,TP,"MAGIC_" + MAGIC,MAGIC,0);
      if (ord=="Buy Stop") ticket=OrderSend(Symbol(),OP_BUYSTOP, Lot,NormalizeDouble(Ask + DistanceSet*Point,Digits),Proskalz,SL,TP,"MAGIC_" + MAGIC,MAGIC,0);
      if (ord=="Sell Stop") ticket=OrderSend(Symbol(),OP_SELLSTOP,Lot,NormalizeDouble(Bid - DistanceSet*Point,Digits),Proskalz,SL,TP,"MAGIC_" + MAGIC,MAGIC,0);
      if (ord=="Buy Limit") ticket=OrderSend(Symbol(),OP_BUYLIMIT, Lot,NormalizeDouble(Ask - DistanceSet*Point,Digits),Proskalz,SL,TP,"MAGIC_" + MAGIC,MAGIC,0);
      if (ord=="Sell Limit") ticket=OrderSend(Symbol(),OP_SELLLIMIT,Lot,NormalizeDouble(Bid + DistanceSet*Point,Digits),Proskalz,SL,TP,"MAGIC_" + MAGIC,MAGIC,0);      
      Message(MAGIC);
      if (ticket==-1) // 
      {  
         ShowERROR();
         err++;Sleep(2000);RefreshRates();
      }
      if (ticket || err >10) return;
   }
return;
} 
//--------------------------------------------------------------------
void Message(string MAGIC) {
  Comment("MAGIC_" + MAGIC);
  Print("MAGIC_" + MAGIC);
}                                      
//--------------------------------------------------------------------
void ShowERROR()
{
   int err=GetLastError();
   switch ( err )
   {                  
      case 1:   return;
      case 2:   Alert("     ",Symbol());return;
      case 3:   Alert("Error   ",Symbol());return;
      case 130: Alert("Error     Ticket ",Symbol());return;
      case 134: Alert("    ",Symbol());return;
      case 146: Alert("Error    ",Symbol());return;
      case 129: Alert("Error   ",Symbol());return;
      case 131: Alert("Error   ",Symbol());return;
      case 4200:Alert("Error    ",Symbol());return;
      default:  Alert("Error  " ,err," ",Symbol());return;
   }
}
//--------------------------------------------------------------------

